using SoftwareInstallationContracts.BindingModels;
using SoftwareInstallationContracts.BusinessLogicsContracts;
using Microsoft.Extensions.Logging;
using SoftwareInstallationContracts.DI;
using SoftwareInstallationBusinessLogic.BusinessLogics;
using SoftwareInstallationBusinessLogic;
using SoftwareInstallationDataModels.Enums;

namespace SoftwareInstallationView
{
	public partial class FormMain : Form
	{
		private readonly ILogger _logger;
		private readonly IOrderLogic _orderLogic;
		private readonly IReportLogic _reportLogic;
		private readonly IWorkProcess _workProcess;
		private readonly IBackUpLogic _backUpLogic;

		public FormMain(ILogger<FormMain> logger, IOrderLogic orderLogic, IReportLogic reportLogic, IWorkProcess workProcess, IBackUpLogic backUpLogic)
		{
			InitializeComponent();
			_logger = logger;
			_orderLogic = orderLogic;
			_reportLogic = reportLogic;
			_workProcess = workProcess;
			_backUpLogic = backUpLogic;
		}
		private void FormMain_Load(object sender, EventArgs e)
		{
			LoadData();
		}
		private void LoadData()
		{
			try
			{
				dataGridView.FillAndConfigGrid(_orderLogic.ReadList(null));
				_logger.LogInformation("Загрузка заказов");
			}
			catch (Exception ex)
			{
				_logger.LogError(ex, "Ошибка загрузки заказов");
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
		private void ComponentsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormComponents>();
			form.ShowDialog();
		}
		private void PackagesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			using var dialog = new SaveFileDialog { Filter = "docx|*.docx" };
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                _reportLogic.SavePackagesToWordFile(new ReportBindingModel { FileName = dialog.FileName });
                MessageBox.Show("Âûïîëíåíî", "Óñïåõ", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
		}
		private void ButtonCreateOrder_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormCreateOrder>();
			form.ShowDialog();
			LoadData();
		}
		private void ButtonTakeOrderInWork_Click(object sender, EventArgs e)
		{
			if (dataGridView.SelectedRows.Count == 1)
			{
				int id = Convert.ToInt32(dataGridView.SelectedRows[0].Cells["Id"].Value);
				_logger.LogInformation("Çàêàç No{id}. Ìåíÿåòñÿ ñòàòóñ íà 'Â ðàáîòå'", id);
				try
				{
					var operationResult = _orderLogic.TakeOrderInWork(new OrderBindingModel { Id = id });
					if (!operationResult)
					{
						throw new Exception("Îøèáêà ïðè ñîõðàíåíèè. Äîïîëíèòåëüíàÿ èíôîðìàöèÿ â ëîãàõ.");
					}
					LoadData();
				}
				catch (Exception ex)
				{
					_logger.LogError(ex, "Îøèáêà ïåðåäà÷è çàêàçà â ðàáîòó");
					MessageBox.Show(ex.Message, "Îøèáêà", MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				}
			}
		}
		private void ButtonOrderReady_Click(object sender, EventArgs e)
		{
			if (dataGridView.SelectedRows.Count == 1)
			{
				int id = Convert.ToInt32(dataGridView.SelectedRows[0].Cells["Id"].Value);
				OrderStatus orderStatus = (OrderStatus)dataGridView.SelectedRows[0].Cells["Status"].Value;
				_logger.LogInformation("Çàêàç No{id}. Ìåíÿåòñÿ ñòàòóñ íà 'Ãîòîâ'", id);
				try
				{
					var operationResult = _orderLogic.FinishOrder(new OrderBindingModel
					{
						Id = id,
						Status = orderStatus
					});
					if (!operationResult)
					{
						throw new Exception("Îøèáêà ïðè ñîõðàíåíèè. Äîïîëíèòåëüíàÿ èíôîðìàöèÿ â ëîãàõ.");
					}
					LoadData();
				}
				catch (Exception ex)
				{
					_logger.LogError(ex, "Îøèáêà îòìåòêè î ãîòîâíîñòè çàêàçà");
					MessageBox.Show(ex.Message, "Îøèáêà", MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}
		private void ButtonIssuedOrder_Click(object sender, EventArgs e)
		{
			if (dataGridView.SelectedRows.Count == 1)
			{
				int id =
				Convert.ToInt32(dataGridView.SelectedRows[0].Cells["Id"].Value);
				_logger.LogInformation("Çàêàç No{id}. Ìåíÿåòñÿ ñòàòóñ íà 'Âûäàí'", id);
				try
				{
					var operationResult = _orderLogic.DeliveryOrder(new
					OrderBindingModel
					{ Id = id });
					if (!operationResult)
					{
						throw new Exception("Îøèáêà ïðè ñîõðàíåíèè.Äîïîëíèòåëüíàÿ èíôîðìàöèÿ â ëîãàõ.");
					}
					_logger.LogInformation("Çàêàç No{id} âûäàí", id);
					LoadData();
				}
				catch (Exception ex)
				{
					_logger.LogError(ex, "Îøèáêà îòìåòêè î âûäà÷è çàêàçà");
					MessageBox.Show(ex.Message, "Îøèáêà", MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				}
			}
		}
		private void ButtonRef_Click(object sender, EventArgs e)
		{
			LoadData();
		}
		private void ComponentsReportToolStripMenuItem_Click(object sender, EventArgs e)
		{
			using var dialog = new SaveFileDialog { Filter = "docx|*.docx" };
			if (dialog.ShowDialog() == DialogResult.OK)
			{
				_reportLogic.SavePackagesToWordFile(new ReportBindingModel
				{
					FileName = dialog.FileName
				});
				MessageBox.Show("Выполнено", "Успех", MessageBoxButtons.OK, MessageBoxIcon.Information);
			}
		}
		private void ComponentPackagesToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormReportPackageComponents>();
			form.ShowDialog();
		}
		private void OrdersToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormReportOrders>();
			form.ShowDialog();

		}

		private void ClientsToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormViewClients>();
			form.ShowDialog();
		}
		private void ImplementersToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormViewImplementers>();
			form.ShowDialog();
		}
		private void DoWorkToolStripMenuItem_Click(object sender, EventArgs e)
		{
			_workProcess.DoWork(DependencyManager.Instance.Resolve<IImplementerLogic>(), _orderLogic);
			MessageBox.Show("Процесс обработки запущен", "Сообщение", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void mailToolStripMenuItem_Click(object sender, EventArgs e)
		{
			var form = DependencyManager.Instance.Resolve<FormViewMail>();
			form.ShowDialog();
		}

		private void createBackupToolStripMenuItem_Click(object sender, EventArgs e)
		{
			try
			{
				if (_backUpLogic != null)
				{
					var fbd = new FolderBrowserDialog();
					if (fbd.ShowDialog() == DialogResult.OK)
					{
						_backUpLogic.CreateBackUp(new BackUpSaveBinidngModel
						{
							FolderName = fbd.SelectedPath
						});
						MessageBox.Show("Бекап создан", "Сообщение",
						MessageBoxButtons.OK, MessageBoxIcon.Information);
					}
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
				MessageBoxIcon.Error);
			}
		}
	}
}